////////////////////////////////////////////////////////////////////////////////
/// @file    delay.c
/// @author  AE TEAM
/// @brief   THIS FILE PROVIDES ALL THE SYSTEM FUNCTIONS.
////////////////////////////////////////////////////////////////////////////////
/// @attention
///
/// THE EXISTING FIRMWARE IS ONLY FOR REFERENCE, WHICH IS DESIGNED TO PROVIDE
/// CUSTOMERS WITH CODING INFORMATION ABOUT THEIR PRODUCTS SO THEY CAN SAVE
/// TIME. THEREFORE, MINDMOTION SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT OR
/// CONSEQUENTIAL DAMAGES ABOUT ANY CLAIMS ARISING OUT OF THE CONTENT OF SUCH
/// HARDWARE AND/OR THE USE OF THE CODING INFORMATION CONTAINED HEREIN IN
/// CONNECTION WITH PRODUCTS MADE BY CUSTOMERS.
///
/// <H2><CENTER>&COPY; COPYRIGHT MINDMOTION </CENTER></H2>
////////////////////////////////////////////////////////////////////////////////

// Files includes
#include "sys_tick.h"
#include "sys_start.h"

void SysTick_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));


extern DEVICE_STRUCT g_dev;
extern uint32_t SystemCoreClock;
static volatile uint32_t TimingDelay;
volatile uint32_t g_sys_tick = 0;
volatile uint32_t g_sys_tick_200us = 0;


#define  TICK_PER_SECOND 5000 //0.2ms

//SysTick ʼ
static void SysTick_Config(uint32_t ticks)
{
    SysTick->CTLR = 0x00000000;             //ƼĴλ
    SysTick->SR = 0x00000000;               //״̬Ĵλ
    SysTick->CNT = 0x00000000;              //λóʼֵΪ0
    SysTick->CMP = ticks;                   //ؼؼĴֵ
    NVIC_SetPriority(SysTicK_IRQn, 15);     //SysTickжȼ
    NVIC_EnableIRQ(SysTicK_IRQn);           //ʹܿSystickж
    SysTick->CTLR |= 0x0000000B;            //ϵͳSTKHCLK/8ʱ
}
void systick_Init(void)
{
    //˴ڽгʼʱñȽϼĴֵ
    SysTick_Config(SystemCoreClock / 40000);//0.2ms
}

static void TimingDelayDecrement(void)
{
    if (TimingDelay != 0x00) {
        TimingDelay--;
    }
}


void SysTick_Handler(void)
{
    SysTick->SR  = 0;
	g_sys_tick_200us ++;
	if(g_sys_tick_200us%5 == 0){
		g_sys_tick++;
		if(g_dev.sys_timeRun >= 1)g_dev.sys_timeRun--;
		TimingDelayDecrement();
	}
}



/**************************************************************************************************
 * @Description : ʱã
 *                ǾʱΪڵǰSYSTICKʱ
 *                    0 ~ +1us
 * @Input       : delay_us  ʱʱ䣨λus
 * @Output      : 
 * @Return      : 
**************************************************************************************************/
void systick_delay_us(uint16_t delay_us)
{
	uint32_t ticks;
    uint32_t told;
    uint32_t tnow;
    uint32_t tcnt = 0;
    uint32_t reload;
       
	reload = SysTick->CMP;
    ticks = delay_us * (SystemCoreClock  / 1000000);	 /* ҪĽ */  
    
    tcnt = 0;
    told = SysTick->CNT;             /* սʱļֵ */

    while (1)
    {
        tnow = SysTick->CNT;
        if (tnow != told)
        {    
            /* SYSTICKһݼļ */    
            if (tnow < told)
            {
                tcnt += told - tnow;    
            }
            /* װصݼ */
            else
            {
                tcnt += reload - tnow + told;    
            }        
            told = tnow;

            /* ʱ䳬/Ҫӳٵʱ,˳ */
            if (tcnt >= ticks){
            	break;
            }
        }  
    }
}



uint32_t sys_getRuntime(void)
{
	return  g_sys_tick;	 
}

uint32_t sys_getRun200us(void)
{
	return  g_sys_tick_200us;	 
}

////////////////////////////////////////////////////////////////////////////////
/// @brief  Set the nTime as delay counter, it is break until counter goes to 0.
/// @note   use TimingDelay.
/// @param  nTime specifies the delay tick number
/// @retval None.
////////////////////////////////////////////////////////////////////////////////
void systick_delay_ms(uint32_t nTime)
{
    TimingDelay = nTime;
    while(TimingDelay != 0);
}



