/*
*********************************************************************************************************
*	ģ : FIFOģ
*	ļ : fifo.c
*	     : V1.0
*	˵     : Ƚȳ -Ϊ
*********************************************************************************************************
*/
#include "fifo.h" 
#include "stdio.h"


/**************************************************************************************************
 * @Description : һbufferfifo
 * @Input       : fifo          ҪĶ
				  buffer        ָҪеݻ
 *                count         buffС
 * @Output      : 
 * @Return      :  
**************************************************************************************************/
void fifo_match_buff(DATA_FIFO* fifo,uint8 *buffer, uint16 count)	
{
	if(buffer == 0){
		return;
	}
	fifo->buffer = buffer;
	fifo->head = fifo->tail = 0;
	fifo->size = count;				
}

/**************************************************************************************************
 * @Description : ѭУCircular Queueд
 * @Input       : buffer        ָҪеݻ
 *                count         Ҫַ
 * @Output      : 
 * @Return      : ɹַ
**************************************************************************************************/
uint16 fifo_in_data( DATA_FIFO* fifo, const uint8 *buffer, uint16 count)
{
    uint16 i = 0;
	//__disable_irq();//ж
	
    if (fifo->buffer == 0){
		//__enable_irq();	//ж
        return 0;
    }
    
	for(i = 0;i<count ;i++) {
        if (FIFO_IS_FULL(fifo->head, fifo->tail, fifo->size))  {
			//__enable_irq();	//ж			
            return i;     
        }
        fifo->buffer[fifo->tail] = buffer[i];
        FIFO_MOVE_NEXT(fifo->tail, fifo->size);
    
	}  
	//__enable_irq();	//ж
    return i;
}

/**************************************************************************************************
 * @Description : ѭгУCircular Queue
 * @Input       : count         ַ
 * @Output      : buffer        ָȡݵbuffer
 * @Return      : ɹַ
**************************************************************************************************/
uint16 fifo_out_data(DATA_FIFO* fifo,uint8 *buffer, uint16 count)
{
    uint16 i = 0;
    
	// __disable_irq();//ж
    if (fifo->buffer == 0){
	 //	__enable_irq();	//ж
        return 0;
    }

    for(i = 0;i<count ;i++){
        if (FIFO_IS_EMPTY(fifo->head, fifo->tail)){
		 //	__enable_irq();	//ж
            return i;     
        }
        buffer[i] = fifo->buffer[fifo->head];
        FIFO_MOVE_NEXT(fifo->head, fifo->size); 
    } 
	// __enable_irq();	//ж	
    return i;
}

/**************************************************************************************************
 * @Description : ǰݳ
 * @Input       : fifo        
 * @Output      :         
 * @Return      : ݳ
**************************************************************************************************/
uint16 fifo_get_currNum(DATA_FIFO* fifo)
{	
	if (fifo == 0){
		return 0;
	}   
    return FIFO_COUNT(fifo->head,fifo->tail, fifo->size); 	
}


