/*
*********************************************************************************************************
*	ģ : FIFOģ
*	ļ : fifo.c
*	     : V1.0
*	˵     : Ƚȳ
*********************************************************************************************************
*/
#ifndef _FIFO_H_
#define _FIFO_H_
 
#include "data_type.h"
 
#define FIFO_IS_EMPTY(head, tail)       (((head) == (tail)) ? TRUE : FALSE)
#define FIFO_IS_FULL(head, tail, size)  (((head) == (tail+1) % (size)) ? TRUE : FALSE)  // tailָĿռԶΪգ˷һռ 
#define FIFO_MOVE_NEXT(node, size)      ((node) = (node+1) % (size))                    // nodeΪheadtail
#define FIFO_COUNT(head, tail, size)    ((((tail)+(size))-(head)) % (size))  

 
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;


typedef struct {
    uint8     *buffer;
    uint16      size;
    uint16      head;
    uint16      tail;
}DATA_FIFO;

/*ӿ*/

/**************************************************************************************************
 * @Description : һbufferfifo
 * @Input       : fifo          ҪĶ
				  buffer        ָҪеݻ
 *                count         buffС
 * @Output      : 
 * @Return      :  
**************************************************************************************************/
void fifo_match_buff(DATA_FIFO* fifo,uint8 *buffer, uint16 count);


/**************************************************************************************************
 * @Description : ѭУCircular Queueд
 * @Input       : fifo          ҪĶ
				  buffer        ָҪеݻ
 *                count         Ҫַ
 * @Output      : 
 * @Return      : ɹַ
**************************************************************************************************/
uint16 fifo_in_data(DATA_FIFO* fifo, const uint8 *buffer, uint16 count);

/**************************************************************************************************
 * @Description : ѭгУCircular Queue
 * @Input       : count         ַ
 * @Output      : buffer        ָȡݵbuffer
 * @Return      : ɹַ
**************************************************************************************************/
uint16 fifo_out_data(DATA_FIFO* fifo,uint8 *buffer, uint16 count);


/**************************************************************************************************
 * @Description : ǰݳ
 * @Input       : fifo        
 * @Output      :         
 * @Return      : ݳ
**************************************************************************************************/
uint16 fifo_get_currNum(DATA_FIFO* fifo);
#endif





