/**************************************************************************************************
 * @File        : mdl_button.c
 * @author		: chengxin
 * @date		:  2020.05.28
 * @Description : ģ-ص
 *                Command Line Interface shell 
**************************************************************************************************/
#include "mdl_button.h"
#include "string.h"

static BOOL btn_event_match(BTN_EVENT* envnt,BTN_DATA *btn);
/*******************************************************************************
 * @Description : ģʼ
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_init(BTN_HANDLE* handle,BTN_INIT* init)
{	
	handle->state = BTN_HANDLE_OK;
	handle->btn_buff = init->btn_buff;
	handle->btn_max_num = init->btn_max_num;
	handle->btn_head = NULL;
	handle->btn_tail = NULL;
	return _SUCCESS;
}

/*******************************************************************************
 * @Description : ģ
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_task(BTN_HANDLE* handle)
{
	BTN_EVENT* event_pr = handle->btn_head;
	uint8 btnData_num = 0;
	if(	handle->state == BTN_HANDLE_NO_INIT ){
		return MDL_PARA_ERR;
	}
	//ӷȡ
	if(handle->btn_read_fun){
		memset(handle->btn_buff,0,handle->btn_max_num*sizeof(BTN_DATA));
		btnData_num = handle->btn_read_fun(handle->btn_buff,handle->btn_max_num);
		if(!btnData_num ) return MDL_UNDEFINE;
		BTN_PRINTF("button num:%d\r\n",btnData_num);
		  
	}
	
	//ƥ䰴
	for(uint8 i = 0;i<btnData_num;i++){
		if(handle->btn_send_fun){
			handle->btn_send_fun(&handle->btn_buff[i]);
		}
		event_pr = handle->btn_head;
		while(event_pr){
			BOOL match_result = btn_event_match(event_pr,&handle->btn_buff[i]);
			if(match_result)BTN_PRINTF("event %d matck ok:%d\r\n",event_pr->eventID);
			event_pr = event_pr->next; 			
		}
	}
	return _SUCCESS;
}

/*******************************************************************************
* @Description : ģ-עȡͷͰķ
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_reg_fun(BTN_HANDLE* handle,BTN_READ_FUN read,BTN_SEND_FUN send)
{
	if( handle == NULL)
		return MDL_PARA_ERR;
	

	if(read == NULL){
		return MDL_PARA_ERR;
	}
	
	if(send == NULL){
		return MDL_PARA_ERR;
	}
	handle->btn_read_fun =  read;
	handle->btn_send_fun =  send;
	return _SUCCESS;
}
	

/*******************************************************************************
 * @Description : ¼ƥ - 
 * @Input       : handle 
 * @Output      : 
 * @Return      : TURE -ƥɹ
				  FALSE -δɹ
********************************************************************************/
static BOOL btn_event_match(BTN_EVENT* envnt,BTN_DATA *btn)
{
	if(envnt->rule[envnt->currNum].buttonID != btn->buttonID){ //ƥID
		envnt->currNum = 0;	//ǰ0
		return FALSE;
	}
	if(envnt->rule[envnt->currNum].state != btn->state){	//ƥ״̬
		envnt->currNum = 0;	 
		return FALSE;
	}
	if(envnt->rule[envnt->currNum].type != btn->type){	//ƥ
		envnt->currNum = 0;	 
		return FALSE;
	}
	
	BOOL is_true = envnt->rule[envnt->currNum].value <= btn->value?TRUE:FALSE;
	if(envnt->rule[envnt->currNum].is_equal_more != is_true){//Ƚֵ
			envnt->currNum = 0;
			return FALSE;
		}
	else envnt->currNum++;	//
			
	if(envnt->currNum == envnt->ruleNum){
		envnt->currNum = 0;//¼,ִлص
		if(envnt->callback){
			envnt->callback(envnt->eventID,btn);
		}
		envnt->totalCnt++;
		return TRUE;	
	}
	return FALSE;
}

/*******************************************************************************
 * @Description : ģһ¼
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_add_event(BTN_HANDLE* handle,BTN_EVENT* btn)
{
	BTN_EVENT* event_pr = handle->btn_head;
	if((btn == NULL)||(handle == NULL)){
		return MDL_PARA_ERR;
	}
	
	//¼
	if(handle->btn_head == NULL){
		handle->btn_head = btn;
		handle->btn_tail = btn;
		btn->next = NULL;
		return _SUCCESS;
	}
	
	while(event_pr){
		//ҵID - ظ¼
		if(event_pr->eventID == btn->eventID){			
			BTN_PRINTF("btn event %d has reged!\r\n",btn->eventID);
			return MDL_FAIL;
		}
		event_pr = event_pr->next;		
	}
	
	//һ¼
	if(handle->btn_head == handle->btn_tail){
		handle->btn_tail = btn;
		btn->next = NULL;
		handle->btn_head->next = btn;
		return _SUCCESS;
	}
	
	handle->btn_tail->next = btn;
	handle->btn_tail = btn;
	btn->next = NULL;
	return _SUCCESS;
}


/*******************************************************************************
 * @Description : ģɾȥһ¼
 * @Input       : handle 
 *				  btn	Ҫӵİ¼ID
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_del_event(BTN_HANDLE* handle,uint8 event_id)
{
	BTN_EVENT* event_pr = handle->btn_head;
	BTN_EVENT* event_ptr =  NULL;
	while(event_pr){
		//ҵID
		if(event_pr->eventID == event_id){
			event_ptr->next = event_pr->next;
			BTN_PRINTF("btn del event %d ok\r\n",event_id);
			return _SUCCESS;
		}
		event_ptr = event_pr;
		event_pr = event_pr->next;		
	}
	BTN_PRINTF("btn del event fail\r\n");
	return MDL_FAIL;
}
/*******************************************************************************
 * @Description : ȡǰ¼
 * @Input       : handle 
 *				  
 * @Output      : 
 * @Return      :  ǰڵ¼
********************************************************************************/
uint16 mdl_btn_get_eventRegNum(BTN_HANDLE* handle)
{
	uint16 cnt = 0;
	BTN_EVENT* event_pr = handle->btn_head;
	while(event_pr){
		cnt++;
		event_pr = event_pr->next;		
	}
	BTN_PRINTF("btn has event %d\r\n",cnt);
	return cnt;	
}

/*******************************************************************************
 * @Description : ȡǰ¼-ִд
 * @Input       : handle 
 *				  
 * @Output      : 
 * @Return      :  ǰڵ¼
********************************************************************************/
uint16 mdl_btn_get_eventRunNum(BTN_HANDLE* handle,uint8 evn_id)
{
	BTN_EVENT* event_pr = handle->btn_head;
	while(event_pr){
		//ҵID
		if(event_pr->eventID == evn_id){
			BTN_PRINTF("btn event %d has run %d \r\n",evn_id,event_pr->totalCnt);
			return event_pr->totalCnt;
		}
		event_pr = event_pr->next;		
	}
	BTN_PRINTF("btn event %d no exist\r\n",evn_id);
	return 0;	
} 






