/**************************************************************************************************
 * @File        : mdl_button.h
 * @author		: chengxin
 * @date		:  2020.05.28
 * @Description : ģ-ص
 *                Command Line Interface shell 
**************************************************************************************************/
#ifndef _MDL_BUTTON_H_
#define _MDL_BUTTON_H_
#include "data_type.h"
#include "error_code.h"

#define BTN_TASK_PERIOD 	5
#define BTN_PRINTF_ENABLE   0

#if      BTN_PRINTF_ENABLE 
 #define BTN_PRINTF(format, ...) 	shellout(format, ##__VA_ARGS__)
 #else
 #define BTN_PRINTF(format, ...)
 #endif
 
//״̬
typedef enum {
	PRESS_UP = 0,	// 
	PRESS_DOWN,		// 
	TURN_LEFT ,		// ת
	TURN_RIGHT,		// ת
	BTN_STATE_COUNT,
}BTNState;

//
typedef enum {
	BTN_VAL_PREVELO = 0,//
	BTN_VAL_ADC  ,//ADCֵ
	BTN_VAL_TIME,//ʱ
	BTN_VAL_COUNT,
}BTN_VAL_TYPE;

//
typedef struct {
	uint8 buttonID;			//
	BTNState	state;//״̬
	uint16 	value;//ֵ
	BTN_VAL_TYPE  type;//ֵ
}BTN_DATA;



//
typedef struct {
	uint8 		buttonID;			
	BTNState	state;
	uint16 		value;
	BOOL     	is_equal_more;	//TRUE  ڻ 
	BTN_VAL_TYPE type;			//FALSE  С 		
}BTN_RULE;

//ص - 
typedef void (*BTN_EVENTCb)(uint8 eventID,BTN_DATA* btnData);

//¼
typedef struct BTN_EVENT{	
	uint8  		 	eventID;	//¼ID
	BTN_RULE* 		rule;		//
	uint8  			ruleNum;	//
	uint8			currNum;	//ǰжϵn
	uint16 			totalCnt;	//¼ִд
	BTN_EVENTCb 		callback;	//¼ص	
	struct BTN_EVENT* next;		//ָһ¼
}BTN_EVENT;



/*
ȡݵķ 
buff 		
want_num 	Ҫȡĳ
 		ȡ
*/
typedef  uint8(*BTN_READ_FUN)(BTN_DATA* buff,uint8 want_num);

/*
Ӧò㴫ÿ 
btnData 		
*/
typedef  void(*BTN_SEND_FUN)(BTN_DATA* btnData);
//״̬
typedef enum{
	BTN_HANDLE_NO_INIT = 0,
	BTN_HANDLE_OK ,	
	BTN_HANDLE_EEROR,		
}BTN_HANDLE_STATE;

//ʼ
typedef struct{
	BTN_DATA*			btn_buff;		//ģʹõĻ
	uint8				btn_max_num;	//һɴ
}BTN_INIT;

//
typedef struct ButtonHandle {
	BTN_HANDLE_STATE 	state;	
	BTN_DATA*			btn_buff;		//ģʹõĻ
	uint16				btn_max_num;		//С
	BTN_EVENT*			btn_head;		//ָһ¼
	BTN_EVENT*			btn_tail;		//ָһ¼
	BTN_READ_FUN	  	btn_read_fun;	//ȡķ		
	BTN_SEND_FUN		btn_send_fun;   //Ͱķ
}BTN_HANDLE;


/*******************************************************************************
 * @Description : ģʼ
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_init(BTN_HANDLE* handle,BTN_INIT* init);

/*******************************************************************************
* @Description : ģ-עȡͷͰķ
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_reg_fun(BTN_HANDLE* handle,BTN_READ_FUN read,BTN_SEND_FUN send);

/*******************************************************************************
 * @Description : ģ
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_task(BTN_HANDLE* handle);

/*******************************************************************************
 * @Description : ģһ¼
 * @Input       : handle 
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_add_event(BTN_HANDLE* handle,BTN_EVENT* btn);


/*******************************************************************************
 * @Description : ģɾȥһ¼
 * @Input       : handle 
 *				  btn	Ҫӵİ¼ID
 * @Output      : 
 * @Return      :  ͨ
********************************************************************************/
ERR_CODE mdl_btn_del_event(BTN_HANDLE* handle,uint8 event_id);

/*******************************************************************************
 * @Description : ȡǰ¼
 * @Input       : handle 
 *				  
 * @Output      : 
 * @Return      :  ǰڵ¼
********************************************************************************/
uint16 mdl_btn_get_eventRegNum(BTN_HANDLE* handle);

/*******************************************************************************
 * @Description : ȡǰ¼-ִд
 * @Input       : handle 
 *				  
 * @Output      : 
 * @Return      :  ǰڵ¼
********************************************************************************/
uint16 mdl_btn_get_eventRunNum(BTN_HANDLE* handle,uint8 evn_id);
#endif


