/* ********************************************************************************************************
*	  : usb.c
*	    : ccx
*	    :  2020-11-10
*	    ־:

********************************************************************************************************* */
#include "usb.h"
#include "ch32v30x_usbotg_device.h"

//
UINT8 usbtestbuf[sizeof(USBHS_HOST)];
extern PUSBHS_HOST Host_Status;
extern volatile UINT8  USBHD_Dev_EnumStatus ;
//usb շ
DATA_FIFO midi_UsbRxFifo;
DATA_FIFO midi_UsbTxFifo;
DATA_FIFO hid_UsbRxFifo;
DATA_FIFO hid_UsbTxFifo;


u8 midi_UsbRxBuf[USB_RX_BUF_SIZE] = {0};
u8 midi_UsbTxBuf[USB_RX_BUF_SIZE] = {0};
u8 hid_UsbRxBuf[USB_RX_BUF_SIZE] = {0};
u8 hid_UsbTxBuf[USB_RX_BUF_SIZE] = {0};
////////////////////////////////////////////////////////////////////////////////
/// @brief  send the received data from USB to the UART 0.
/// @param  None.
/// @retval None.
////////////////////////////////////////////////////////////////////////////////
//
//midi
u32 usb_midiRead(u8* buffter, u32 buffterSize)
{
     if( USBHD_Dev_EnumStatus == 0 )  return 0;
     else return fifo_out_data(&midi_UsbRxFifo, buffter, buffterSize);
}

//hid
u32 usb_hidRead(u8* buffter, u32 buffterSize)
{
    return fifo_out_data(&hid_UsbRxFifo, buffter, buffterSize);
}

//дmidi
u32 usb_midiWrite(u8* buffter, u32 buffterSize)
{
    if( USBHD_Dev_EnumStatus == 0 )  return 0;
    else return fifo_in_data(&midi_UsbTxFifo, buffter, buffterSize);
}

//дhid
u32 usb_hidWrite(u8* buffter, u32 buffterSize)
{
   return fifo_in_data(&hid_UsbTxFifo, buffter, buffterSize);
}


//usb óʼ
void usb_cfgInit(void)
{	

    Host_Status = (PUSBHS_HOST)usbtestbuf;//host
    USBHS_HostInit(ENABLE);
    USBOTG_Init();//device
}

//usb óʼ
void usb_dataInit(void)
{			
	fifo_match_buff (&midi_UsbTxFifo, midi_UsbTxBuf, sizeof(midi_UsbTxBuf)); //Create a receive queue
	fifo_match_buff(&midi_UsbRxFifo, midi_UsbRxBuf, sizeof(midi_UsbRxBuf)); //Create a receive queue
	fifo_match_buff(&hid_UsbRxFifo, hid_UsbRxBuf, sizeof(hid_UsbRxBuf)); //Create a receive queue
	fifo_match_buff(&hid_UsbTxFifo, hid_UsbTxBuf, sizeof(hid_UsbTxBuf)); //Create a receive queue
}


void usb_init(void)
{
	usb_dataInit();
	usb_cfgInit();	
	
}
 

//ʱ
u8 Send_Buffer[64];
//extern Device_Struct g_dev;
void usb_txTask(void)
{
    UINT8 i =0;
    if( USBHD_Dev_EnumStatus == 2 ){//óɹ
        if( !USBHD_Endp1_Up_Flag){   //жϴǷ
            memset(Send_Buffer,0,sizeof(Send_Buffer));
            uint8 send_len =    fifo_out_data(&midi_UsbTxFifo, Send_Buffer, 64);
            if(send_len){
                for(i=0; i<send_len; i++)
                {
                    pEP1_IN_DataBuf[i] =  Send_Buffer[i];
                }
                DevEP1_IN_Deal( send_len );
            }
        }
    }
}

void usbHost_task(void)
{
    UINT8 ret;
    if(USBHSH->INT_FG & USBHS_DETECT_FLAG)
    {
        USBHSH->INT_FG = USBHS_DETECT_FLAG;
        if(USBHSH->MIS_ST & USBHS_ATTCH)
        {
            SetBusReset();
            ret = USBHS_HostEnum();
            if(ret == ERR_SUCCESS )
            {
                printf("enum success\r\n");
            }
            else
            {
                printf("enum error\r\n");
            }
        }
        else
        {
            USBHS_HostInit(DISABLE);
            USBHS_HostInit(ENABLE);
            printf("disconnect\r\n");
        }
    }
}




