/******************** (C) COPYRIGHT 2009 STMicroelectronics ********************
* File Name          : usb_desc.h
* Author             : MCD Application Team
* Version            : V3.0.1
* Date               : 04/27/2009
* Description        : Descriptor Header for Custom HID Demo
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __USB_DESC_H
#define __USB_DESC_H

#include "data_type.h"

#define wTransferSize               0x0400   /* wTransferSize   = 1024 bytes */

/* Includes ------------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
#define DEV_LANG_STR_IDX                          0x00
#define DEV_COMPANY_STR_IDX                       0x01
#define DEV_PROD_STR_IDX                          0x02
#define DEV_SN_STR_IDX                            0x03
#define DEV_IF0_STR_IDX                           0x04

#define MIDI_SIZ_DEVICE_DESC                       18
#define MIDI_SIZ_CONFIG_DESC                       133  
#define HID_SIZ_REPORT_DESC                       49  //Zhixing 200421 Change;

#define MIDI_SIZ_STRING_LANGID                     4
#define MIDI_SIZ_STRING_VENDOR                     10	 
#define MIDI_SIZ_STRING_PRODUCT                    30
#define MIDI_SIZ_STRING_SERIAL                     30
#define MIDI_SIZ_STRING_INTERFACE0                 24
#define MIDI_SIZ_STRING_HIDDFU            26

#define USB_DEVICE_DESCRIPTOR_TYPE                0x01
#define USB_CONFIGURATION_DESCRIPTOR_TYPE         0x02
#define USB_STRING_DESCRIPTOR_TYPE                0x03
#define USB_INTERFACE_DESCRIPTOR_TYPE             0x04
#define USB_ENDPOINT_DESCRIPTOR_TYPE              0x05
#define USB_POWER_DESCRIPTOR_TYPE                 0x06
#define USB_IAD_DESCRIPTOR_TYPE                   0x0B
#define HID_DESCRIPTOR_TYPE                       0x21

/****************************************************************************/ 
#define DEVICE_VERSION    ((unsigned short)0x2021)	 //00.21
#define VENDOR_ID         ((unsigned short)0x1ACC)   //MIDIPLUS	   
#define PRODUCT_ID        ((unsigned short)0x1A73)   //apx1
	
#define DEVICE_VER_LSB    (unsigned char)(DEVICE_VERSION & 0x00FF)  //Zhixing 200421 Add;
#define DEVICE_VER_MSB    (unsigned char)(DEVICE_VERSION / 256)     //Zhixing 200421 Add;

/****************************************************************************/
#define HIWORD(para)   ((unsigned char)(para >> 8))
#define LOWORD(para)   ((unsigned char)(para & 0xFF))

#define STANDARD_ENDPOINT_DESC_SIZE             0x09   

#define	REPORT_COUNT				64	   //˵㳤

/* Exported functions ------------------------------------------------------- */
extern uint8 MIDI_DeviceDescriptor[MIDI_SIZ_DEVICE_DESC];	 //豸
extern uint8 MIDI_ConfigDescriptor[MIDI_SIZ_CONFIG_DESC];	 //
extern uint8 MIDI_StringLangID[MIDI_SIZ_STRING_LANGID];	 //IDַ
extern uint8 MIDI_StringVendor[MIDI_SIZ_STRING_VENDOR];	 //ַ
extern uint8 MIDI_StringProduct[MIDI_SIZ_STRING_PRODUCT];	 //Ʒַ
extern uint8 MIDI_StringSerial[MIDI_SIZ_STRING_SERIAL];		 //кַ
extern uint8 MIDI_StringInterface0[MIDI_SIZ_STRING_INTERFACE0];		 //кַ
extern uint8 HidMIDI_ReportDescriptor[HID_SIZ_REPORT_DESC];	 //


#endif /* __USB_DESC_H */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
