/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : ccx
* Version            : V1.0.0
* Date               : 2022/01/18
* Description        : Main program body.
*******************************************************************************/


#include "debug.h"
#include "usb.h"
#include "gpio.h"
#include "sys_start.h"
#include "sys_tick.h"



//* ⲿ
extern DEVICE_STRUCT g_dev;
void driver_init(void)
{
    systick_Init();
    ////  driver_uart1Init();
    gpio_init();
    ////  adc_init();
    ////  led_init();
    usb_init();
    //    ws2812_init();
    //    //iwdg_init();
}

uint8_t tempBuff[64];
uint8_t tempLen = 0;
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);

	driver_init();
    /* USBOTG_FS device init */
	while(1)
	{
        if(g_dev.sys_timeRun == 0)
        {
            g_dev.sys_timeRun = 200;
            GPIOA->OUTDR ^= GPIO_Pin_0;
            GPIOA->OUTDR ^= GPIO_Pin_1;
            //printf( "hello world\r\n" );
        }

        if(USBmidi_recvRemainNum())
        {
            tempLen = usb_midiRead(tempBuff,64);
            usb_midiWrite(tempBuff, tempLen);
        }
        usb_txTask();
        usbHost_task();
	}
}



